// Generated by CoffeeScript 1.10.0
(function() {
  var DepGraph, _,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  _ = require('underscore');

  DepGraph = (function() {
    function DepGraph() {
      this.map = {};
    }

    DepGraph.prototype.add = function(id, depId) {
      var base;
      if ((base = this.map)[id] == null) {
        base[id] = [];
      }
      if (indexOf.call(this.map[id], depId) >= 0) {
        return false;
      }
      this.map[id].push(depId);
      return this.map[id];
    };

    DepGraph.prototype.getChain = function(id) {
      var chain, deps, i, leafNode, len, ref, visit, visited;
      deps = this.descendantsOf(id);
      chain = [];
      visited = {};
      visit = (function(_this) {
        return function(node) {
          var i, len, parent, ref;
          if (visited[node] || node === id) {
            return;
          }
          visited[node] = true;
          ref = _this.parentsOf(node);
          for (i = 0, len = ref.length; i < len; i++) {
            parent = ref[i];
            if (indexOf.call(deps, parent) >= 0) {
              visit(parent);
            }
          }
          return chain.unshift(node);
        };
      })(this);
      ref = _.intersection(deps, this.leafNodes()).reverse();
      for (i = 0, len = ref.length; i < len; i++) {
        leafNode = ref[i];
        visit(leafNode);
      }
      return chain;
    };

    DepGraph.prototype.leafNodes = function() {
      var allNodes, i, len, node, ref, results;
      allNodes = _.uniq(_.flatten(_.values(this.map)));
      results = [];
      for (i = 0, len = allNodes.length; i < len; i++) {
        node = allNodes[i];
        if (!((ref = this.map[node]) != null ? ref.length : void 0)) {
          results.push(node);
        }
      }
      return results;
    };

    DepGraph.prototype.parentsOf = function(child) {
      var i, len, node, ref, results;
      ref = _.keys(this.map);
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        node = ref[i];
        if (indexOf.call(this.map[node], child) >= 0) {
          results.push(node);
        }
      }
      return results;
    };

    DepGraph.prototype.descendantsOf = function(parent, descendants, branch) {
      var child, i, len, ref, ref1;
      if (descendants == null) {
        descendants = [];
      }
      if (branch == null) {
        branch = [];
      }
      descendants.push(parent);
      branch.push(parent);
      ref1 = (ref = this.map[parent]) != null ? ref : [];
      for (i = 0, len = ref1.length; i < len; i++) {
        child = ref1[i];
        if (indexOf.call(branch, child) >= 0) {
          throw new Error("Cyclic dependency from " + parent + " to " + child);
        }
        if (indexOf.call(descendants, child) >= 0) {
          continue;
        }
        this.descendantsOf(child, descendants, branch.slice(0));
      }
      return descendants.slice(1);
    };

    return DepGraph;

  })();

  if ((typeof module !== "undefined" && module !== null ? module.exports : void 0) != null) {
    module.exports = DepGraph;
  } else {
    this.DepGraph = DepGraph;
  }

}).call(this);
